Ubuntu

lightdm should allow packages to override defaults in /etc/lightdm/lightdm.conf

Reported by Steve Langasek on 2013-06-13
18
This bug affects 3 people
Affects Status Importance Assigned to Milestone
Light Display Manager
Wishlist
Unassigned
1.2
Wishlist
Unassigned
1.4
Wishlist
Unassigned
1.6
Wishlist
Unassigned
lightdm (Ubuntu)
Wishlist
Unassigned
Precise
Wishlist
Unassigned

Bug Description

[Impact]
  The /etc/lightdm/lightdm.conf file is a conffile, which means that packages are not allowed to modify it.

  As a result, if any package is modifying /etc/lightdm/lightdm.conf on installation to set 'greeter-show-manual-login=true', will cause users of this package to have conffile prompts on future upgrades.

It would be helpful if lightdm had some supported mechanism for packages to override the defaults in /etc/lightdm/lightdm.conf - such as an /etc/lightdm/lightdm.conf.d directory .

[Test Case]
  * Create autologin file, as shown below. This will fail on precise, but work fine on saucy/trusty.

  $ cat /etc/lightdm/lightdm.conf.d/10-ubuntu.conf
  [SeatDefaults]
  autologin-user=ubuntu-or-any-other-user-on-system

[Regression Potential]
  * none that I could see, and is backport from upstream

[Other Info]
  * Has been tested, and works.
  * Merge https://code.launchpad.net/~lightdm-team/lightdm/1.2 against precise

Steve Langasek (vorlon) wrote :
Robert Ancell (robert-ancell) wrote :

Agree to the concept, however when I have previously looked into this I haven't come to a conclusion what the correct way of handling this is:
- Should the .d directory to .conf be done inside LightDM, or by the OS / packaging system?
- What to do when keys conflict?
- What if a program requires a certain combination of keys? Will it still work if some of them are overridden by another package?

Changed in lightdm (Ubuntu):
status: New → Triaged
importance: Undecided → Wishlist

On Thu, Jun 13, 2013 at 03:14:04AM -0000, Robert Ancell wrote:
> Agree to the concept, however when I have previously looked into this I haven't come to a conclusion what the correct way of handling this is:
> - Should the .d directory to .conf be done inside LightDM, or by the OS /
> packaging system?

What gives the best results is if lightdm can parse this itself. Otherwise
you have the problem of various files in /etc, some of which are
authoritative and can be edited, some of which aren't and will be
overwritten.

> - What to do when keys conflict?

As long as there's a well-defined lexicographical order in which the files
are read, and a consistent policy of which key wins (first instance wins vs.
last instance wins), I don't think it's a problem.

> - What if a program requires a certain combination of keys? Will it still
> work if some of them are overridden by another package?

Well, presumably all possible combinations of keys should be valid from
lightdm's POV, otherwise the keys should be consolidated. :) This feels to
me like a problem that can be punted over to any such packages that are
requesting contradictory settings, to let them figure it out amongst
themselves.

Changed in lightdm:
status: New → Triaged
importance: Undecided → Wishlist
PS Jenkins bot (ps-jenkins) wrote :

Fix committed into lp:lightdm at revision None, scheduled for release in lightdm, milestone Unknown

Changed in lightdm:
status: Triaged → Fix Committed
Changed in lightdm:
milestone: none → 1.7.3
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package lightdm - 1.7.3-0ubuntu1

---------------
lightdm (1.7.3-0ubuntu1) saucy; urgency=low

  * New upstream release:
    - Load configuration from /etc/lightdm/lightdm.conf.d. (LP: #1190425)
    - Fix compile warnings
    - Fix tests not running from install directory inside checkout.
 -- Robert Ancell <email address hidden> Fri, 21 Jun 2013 14:39:27 +1200

Changed in lightdm (Ubuntu):
status: Triaged → Fix Released
description: updated
Changed in lightdm (Ubuntu Precise):
status: New → Triaged
Changed in lightdm (Ubuntu Quantal):
status: New → Triaged
Changed in lightdm (Ubuntu Raring):
status: New → Triaged
importance: Undecided → Wishlist
Changed in lightdm (Ubuntu Quantal):
importance: Undecided → Wishlist
Changed in lightdm (Ubuntu Precise):
importance: Undecided → Wishlist
Robert Ancell (robert-ancell) wrote :

I'm assuming since Quantal and Raring are so close to end-of-life (April 2014 and January 2014 respectively) that it is unlikely that anyone will upgrade from precise to these releases and thus loose this feature. If you are on this releases you can always compile the packages with this support yourself from lp:lightdm/1.4 and lp:lightdm/1.6.

no longer affects: lightdm (Ubuntu Quantal)
no longer affects: lightdm (Ubuntu Raring)

Hello Steve, or anyone else affected,

Accepted lightdm into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/lightdm/1.2.3-0ubuntu2.4 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in lightdm (Ubuntu Precise):
status: Triaged → Fix Committed
tags: added: verification-needed
katsu (yoko-katsu) wrote :

verify condition: ubuntu 12.04.3 in virtualbox.

--------------------
[test case]
$ sudo mkdir -p /etc/lightdm/lightdm.conf.d
$ create 10-ubuntu.conf
$ cat /etc/lightdm/lightdm.conf.d/10-ubuntu.conf
[SeatDefaults]
autologin-user=username-on-system

- system reboot
-> I can't autologin
--------------------

enable precise proposed & install lightdm package

$ sudo apt-get install -t precise-proposed lightdm

upgrade lightdm 1.2.3-0ubuntu2.3 1.2.3-0ubuntu2.4

--------------------
[verification case]
$ sudo mkdir -p /etc/lightdm/lightdm.conf.d
$ create 10-ubuntu.conf
$ cat /etc/lightdm/lightdm.conf.d/10-ubuntu.conf
[SeatDefaults]
autologin-user=username-on-system

- system reboot
-> I can autologin
(delete 10-ubuntu.conf or /etc/lightdm/lightdm.conf.d -> I can't autologin)
--------------------

good works & thank you.

Jonathan Davies (jpds) on 2014-01-29
tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package lightdm - 1.2.3-0ubuntu2.4

---------------
lightdm (1.2.3-0ubuntu2.4) precise-proposed; urgency=low

  [ Robert Ancell ]
  * debian/patches/06_config_directory.patch:
    - Backport conf.d configuration support (LP: #1190425)

  [ Alberto Milone ]
  * debian/patches/07_add_display-stopped-script.patch:
    - Backport support for the display-stopped-script entry
      in the configuration file (LP: #1259237)
 -- Alberto Milone <email address hidden> Wed, 18 Dec 2013 14:31:49 +0100

Changed in lightdm (Ubuntu Precise):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for lightdm has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers